aboutsummaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
authorHeikki Halmet <heikki.halmet@qt.io>2022-09-26 07:57:49 +0300
committerHeikki Halmet <heikki.halmet@qt.io>2022-10-11 17:16:18 +0300
commit9255466d9fd25d33da2c12899b284320e26480e6 (patch)
treec8e721dfec4bfdfa0022e5ffbeebb3513810fb49
parent5398865f8ab45d72a80803fd62713b6ac1eeece3 (diff)
Provisioning: Use OpenSSL 3 version with Red Hat 9
OpenSSL 3 is default version when installing OpenSSL with yum. We need to use OpenSSL 3 also with Android Change-Id: If283c68d00d9a41131044fe245b5e84b39fd4744 Reviewed-by: Toni Saario <toni.saario@qt.io> Reviewed-by: Assam Boudjelthia <assam.boudjelthia@qt.io>
-rwxr-xr-xcoin/provisioning/common/unix/openssl_3_for_android.sh98
-rwxr-xr-xcoin/provisioning/qtci-linux-RHEL-9.0-x86_64/50-openssl_for_android_linux.sh2
2 files changed, 99 insertions, 1 deletions
diff --git a/coin/provisioning/common/unix/openssl_3_for_android.sh b/coin/provisioning/common/unix/openssl_3_for_android.sh
new file mode 100755
index 00000000..c82fa51c
--- /dev/null
+++ b/coin/provisioning/common/unix/openssl_3_for_android.sh
@@ -0,0 +1,98 @@
+#!/usr/bin/env bash
+
+#############################################################################
+##
+## Copyright (C) 2022 The Qt Company Ltd.
+## Contact: https://www.qt.io/licensing/
+##
+## This file is part of the provisioning scripts of the Qt Toolkit.
+##
+## $QT_BEGIN_LICENSE:LGPL$
+## Commercial License Usage
+## Licensees holding valid commercial Qt licenses may use this file in
+## accordance with the commercial license agreement provided with the
+## Software or, alternatively, in accordance with the terms contained in
+## a written agreement between you and The Qt Company. For licensing terms
+## and conditions see https://www.qt.io/terms-conditions. For further
+## information use the contact form at https://www.qt.io/contact-us.
+##
+## GNU Lesser General Public License Usage
+## Alternatively, this file may be used under the terms of the GNU Lesser
+## General Public License version 3 as published by the Free Software
+## Foundation and appearing in the file LICENSE.LGPL3 included in the
+## packaging of this file. Please review the following information to
+## ensure the GNU Lesser General Public License version 3 requirements
+## will be met: https://www.gnu.org/licenses/lgpl-3.0.html.
+##
+## GNU General Public License Usage
+## Alternatively, this file may be used under the terms of the GNU
+## General Public License version 2.0 or (at your option) the GNU General
+## Public license version 3 or any later version approved by the KDE Free
+## Qt Foundation. The licenses are as published by the Free Software
+## Foundation and appearing in the file LICENSE.GPL2 and LICENSE.GPL3
+## included in the packaging of this file. Please review the following
+## information to ensure the GNU General Public License requirements will
+## be met: https://www.gnu.org/licenses/gpl-2.0.html and
+## https://www.gnu.org/licenses/gpl-3.0.html.
+##
+## $QT_END_LICENSE$
+##
+#############################################################################
+
+# This script install prebuilt OpenSSL which was built against Android NDK 21.
+# OpenSSL build will fail with Android NDK 22, because it's missing platforms and sysroot directories
+
+set -ex
+# shellcheck source=../unix/DownloadURL.sh
+source "${BASH_SOURCE%/*}/../unix/DownloadURL.sh"
+# shellcheck source=../unix/SetEnvVar.sh
+source "${BASH_SOURCE%/*}/../unix/SetEnvVar.sh"
+
+version="3.0.3"
+: ' SOURCE BUILD INSTRUCTIONS - Openssl prebuilt was made using Android NDK 21
+# Source built requires GCC and Perl to be in PATH.
+exports_file="/tmp/export.sh"
+# source previously made environmental variables.
+if uname -a |grep -q "Ubuntu"; then
+ # shellcheck disable=SC1090
+ grep -e "^export" "$HOME/.profile" > $exports_file && source $exports_file
+ rm -rf "$exports_file"
+else
+ # shellcheck disable=SC1090
+ grep -e "^export" "$HOME/.bashrc" > $exports_file && source $exports_file
+ rm -rf "$exports_file"
+fi
+
+officialUrl="https://www.openssl.org/source/openssl-$version.tar.gz"
+cachedUrl="http://ci-files01-hki.intra.qt.io/input/openssl/openssl-$version.tar.gz"
+targetFile="/tmp/openssl-$version.tar.gz"
+sha="1138de3f1a2f573ae69302ab52ecd9bbf5e063ca"
+opensslHome="${HOME}/openssl/android/openssl-${version}"
+DownloadURL "$cachedUrl" "$officialUrl" "$sha" "$targetFile"
+mkdir -p "${HOME}/openssl/android/"
+tar -xzf "$targetFile" -C "${HOME}/openssl/android/"
+if uname -a |grep -q "Darwin"; then
+ TOOLCHAIN=${ANDROID_NDK_ROOT}/toolchains/llvm/prebuilt/darwin-x86_64/bin
+else
+ TOOLCHAIN=${ANDROID_NDK_ROOT}/toolchains/llvm/prebuilt/linux-x86_64/bin
+fi
+cd "$opensslHome"
+PATH=$TOOLCHAIN:$PATH CC=clang ./Configure android-arm
+PATH=$TOOLCHAIN:$PATH CC=clang make build_generated
+'
+
+if uname -a |grep -q "Darwin"; then
+ prebuiltUrl="http://ci-files01-hki.intra.qt.io/input/openssl/prebuilt-openssl-3.0.3-for-android-ndk-r23b-darwin.tar.gz"
+ sha="d204cb4011ba8672aec62ab36a00dd3e32a3a5e9"
+else
+ prebuiltUrl="http://ci-files01-hki.intra.qt.io/input/openssl/prebuilt-openssl-3.0.3-for-android-ndk-r23b-linux.tar.gz"
+ sha="2d1b6f5d90b5e3ae6a7e2a376250c66e99371485"
+fi
+targetFile="/tmp/prebuilt-openssl-$version.tar.gz"
+DownloadURL "$prebuiltUrl" "$prebuiltUrl" "$sha" "$targetFile"
+tar -xzf "$targetFile" -C "${HOME}"
+
+opensslHome="${HOME}/openssl/android/openssl-${version}"
+SetEnvVar "OPENSSL_ANDROID_HOME" "$opensslHome"
+
+echo "OpenSSL for Android = $version" >> ~/versions.txt
diff --git a/coin/provisioning/qtci-linux-RHEL-9.0-x86_64/50-openssl_for_android_linux.sh b/coin/provisioning/qtci-linux-RHEL-9.0-x86_64/50-openssl_for_android_linux.sh
index 05306ed1..edc0ddf1 100755
--- a/coin/provisioning/qtci-linux-RHEL-9.0-x86_64/50-openssl_for_android_linux.sh
+++ b/coin/provisioning/qtci-linux-RHEL-9.0-x86_64/50-openssl_for_android_linux.sh
@@ -41,4 +41,4 @@
set -ex
# shellcheck source=../common/unix/openssl_for_android.sh
-source "${BASH_SOURCE%/*}/../common/unix/openssl_for_android.sh"
+source "${BASH_SOURCE%/*}/../common/unix/openssl_3_for_android.sh"